#include <avr/io.h>
#include <avr/interrupt.h>
#include "LED.h"



long Uin = 512, Uout = 512; //         [  ]
unsigned int Nin = 1, Nout = 1;	//    .
unsigned int Print_in, Print_out; //    LED       [  ]
const unsigned int U0_ = 130, U1_ = 150, U2_ = 170, U3_ = 190, U4_ = 210, U5_ = 230, U6_ = 250, U7_ = 270;
unsigned char Out;



ISR(ADC_vect)			//  -  .
{//////////////////////////////////////////////////////////////////////////////////////////////////////
if ((ADMUX & 1) == 0)	//   Uin
	{
	Uin = Uin + ADCW;	//    ,
	Nin++;				//  - ,
	ADMUX = ADMUX | 1; 	//      Uout
	}
else					//   Uout
	{
	Uout = Uout + ADCW; //    ,
	Nout++;				//  - ,
	ADMUX = ADMUX & 0b11111110;	//      Uin,
	}
ADCSRA = ADCSRA | 64;	//   .
}



ISR(TIMER1_OVF_vect) 	// -  T/C3.
{//////////////////////////////////////////////////////////////////////////////////////////////////////
Print_in = (Uin / Nin) * 10 / 25; 	 //         65.535 ,     
Print_out = (Uout / Nout) * 10 / 25; //         65.535 ,     
 
 /*    10 ,    ,   2.56V    ADCW,  1023. 
   ,     u = 409.2V (U = 578.696V).
      ADCW = 1023  U = 578.696V (u = 409.2V),       2.56V.
 , , u = 220 (U = 311.127V)    ADCW = 777.817V,       1.376V.
 .. Print_in(out)   2.5,    . */

 Nin = 1, Nout = 1;	//    

 //       
 if (Print_in > U7_) Out = 128;								// > 270   
 else if (Print_in > U6_) Out = 64;							// > 250...270
 	else if (Print_in > U5_) Out = 32;						// > 230...250
 		else if (Print_in > U4_) Out = 16;					// > 210...230
 			else if (Print_in > U3_) Out = 8;				// > 190...210
 				else if (Print_in > U2_) Out = 4;			// > 170...190
 					else if (Print_in > U1_) Out = 2;		// > 150...170
 						else Out = 1; 						// < 150   

 if (Out != PINB) PINB = 0; //     ,  ,    
 
 while ((PINC & 1) != 1);	//    ,  .
 PINC = Out; 				//       .
}



///////////////////////////////////////////////////////////////////////////////////////////////////////
int main (void)	///////////////////////////////////////////////////////////////////////////////////////
{//////////////////////////////////////////////////////////////////////////////////////////////////////
	//  
		DDRA = 0b11111100;
		//		 ||||||00 -  ADC.
		//		 111111 - ,    .
		PORTA = 0b11111100;
		//		  ||||||00 -   ADC  .
		//		  111111 -   .
	DDRB = 0xFF;	//     - .
	PORTB = 0;		//     .
		DDRC = 0;				//    JTAG.
		PORTC = 0b00000001;		//    .
	DDRD = 0xFF;	// .
	PORTD = 0;		//     .

	//  
		ADCSRA = 0b11001111;
		//         |||||111 - .  = 128: 8000000 / 128 = 62500 [Hz]
		//         ||||1 -    .
		//         |||0 -    .
		//         ||0 -   .
		//         |1 -  .
		//         1 -   .
	ADMUX = 0b11000000;
	//        ||000000 -  .  - ADC0 (PF0).
	//		  ||000001 -  .  - ADC1 (PF1).
	//        11-   = 2.56V.

	//   / ר T/C1
	TCCR1B = 0b010;
	//		   010 CS32...CS30 -   T/C1 = Ft / 256 = 8000000 / 8 = 1000000 .(T = 1us)
	//		     T/C3   1us * 65535 = 65535us = 65.536ms.
				
	TIMSK = 0b100;
	// 		  1 TOIE1      T1

	while (1)		//   ( ,   LED)
	{
	LED(Print_in, Print_out);
	}
}
